/***************************************************************************
                          missionselector  -  description
                             -------------------
    begin                : Fri Jan 30 2004
    copyright            : (C) 2004 by Thomas Friedrichsmeier
    email                : tfry@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef MISSIONSELECTOR_H
#define MISSIONSELECTOR_H

#include <qdialog.h>
#include <qmap.h>
#include "tpbase.h"

class QPushButton;
class QListView;
class QListViewItem;
class QTextEdit;
class QCheckBox;
class QString;

/**
Allow selection of (and scanning for) mission(s) to play.

@author Debian User,,,
*/
class MissionSelector : public QDialog, public TPBase {
  Q_OBJECT
public:
/** constructor. If scan, scan for new missions */
	MissionSelector(bool scan=false);
/** destructor */
	~MissionSelector();

public slots:
/** the add Button was pressed. Prompt for single mission(s) to add */
	void addButtonPressed ();
/** the scan Button was pressed. Prompt for directory to scan */
	void scanButtonPressed ();
/** the del Button was pressed. Remove selected missoin(s) from list */
	void delButtonPressed ();
/** the ok Button was pressed. Prompt for single mission(s) to add */
	void okButtonPressed ();
/** the selection changed. (De-)activate buttons accordingly */
	void selectionChanged ();
private:
/** read in basic descriptions for all known missions */
	void initialize ();
/** add a single mission */
	void addMission (const QString & filename);

	QTextEdit *description;
	QListView *missionlist;

	QPushButton *delbutton;
	QPushButton *okbutton;
	QCheckBox *select_on_startup_box;

	QMap<QListViewItem *, QString> abstracts;
};

#endif
